"use strict";
//SecretAgent
// 
//Licence Terms
// 
//1) SecretAgent is copyright Peter John
//
//You may;
//
//2) Download and install SecretAgent software for personal or commercial use
//
//3) You may use SecretAgent software on as many computers as you wish, without charge
//
//4) You may decompile the software, but only to verify the code will perform to specification
//
//You may not;
//
//5) Rebrand or bundle the code, or any part of the code, with any other software product
//
//6) Incorporate the code into a product or service involving Phorm or any other advertising system
//
//Specific Restrictions;
//
//7) SecretAgent software is not licenced for use by employees or sub-contractors working for Phorm, BT, Plusnet, TalkTalk, Virgin, Vodafone, BBC, News Corporation, News International, Logica, Experian, Verizon, Facebook, Schillings, Berenberg, Blackrock, Dartley Bank, Baker & McKenzie
//
//8) SecretAgent software is not licenced for use by employees or sub-contractors working for UK Central Government (including but not limited to the Information Commissioners Office, Home Office, Ministry of Justice, Dept for Business Innovation and Skills, Cabinet Office, Ministry of Defence, Foreign Office, Department for Education).
//
//9) SecretAgent software is not licenced for use by employees or sub-contractors working for UK Police forces
// 

window.addEventListener("load", function() {
   SecretAgent.init();
}, false);
window.addEventListener("unload", function() {
   SecretAgent.uninit();
}, false);

// ------------------------------------------------------------------------------------------------
// Mozilla ISODateString (backward compatible)
function ISODateString(d) {
   function pad(n) {
      return n < 10 ? '0' + n : n
   }
   return d.getUTCFullYear() + '-' + pad(d.getUTCMonth() + 1) + '-' + pad(d.getUTCDate()) + 'T' + pad(d.getUTCHours()) + ':' + pad(d.getUTCMinutes()) + ':' + pad(d.getUTCSeconds()) + 'Z'
}

// ------------------------------------------------------------------------------------------------
// Show the SecretAgent preferences dialog
function openSecretAgentPrefs() {
   window.openDialog("chrome://SecretAgent/content/preferences.xul", "SecretAgent Prefs", "centerscreen, chrome, toolbar, dialog=no, resizable, modal");

   // Initialise Agents
   SecretAgent.initialiseUserAgentList();

   // Initialise Accept headers
   SecretAgent.initialiseAcceptList();

   // Initialise OSCPU strings
   SecretAgent.initialiseOSCPUList();

   // Initialise Whitelist
   SecretAgent.initialiseWhitelist();

   var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].
   getService(Components.interfaces.nsIPrefService);
   secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");

   // Check Status and Set the status message
   if (secretAgentPreferences.getBoolPref("StealthMode")) {
      SecretAgent.on();
   } else {
      SecretAgent.off();
   }

}

// ------------------------------------------------------------------------------------------------
// SecretAgent Addon Listener - used to detect uninstall operations, and restore defaults
var SecretAgentAddonListener = {
   onUninstalling: function(addon, needsRestart) {
      if (addon.id == "SecretAgent@Dephormation.org.uk") {
         dump("SecretAgent: removing all overrides ready for uninstall.\n");
         // Remove all overrides
         SecretAgent.off();
      }
   },

   onDisabling: function(addon, needsRestart) {
      if (addon.id == "SecretAgent@Dephormation.org.uk") {
         dump("SecretAgent: removing all overrides ready for disable.\n");
         // Remove all overrides
         SecretAgent.off();
      }
   },

   onEnabled: function(addon) {
      if (addon.id == "SecretAgent@Dephormation.org.uk") {
         dump("SecretAgent: switching SecretAgent on ready for enable.\n");
         // Enable overrides
         SecretAgent.on();
      }
   }
};

try {
   Components.utils.import("resource://gre/modules/AddonManager.jsm");
   AddonManager.addAddonListener(SecretAgentAddonListener);
} catch (e) {
   dump("SecretAgent: Failed to install addon listener: " + e.message);
}

// ------------------------------------------------------------------------------------------------
// SecretAgent Status Bar/Toolbar Button OnClick Event Handler 
function SecretAgentOnClickEventHandler(e) {
   var buttonCode = e.button;

   switch (buttonCode) {
      case 0: // Left button clicked
         SecretAgent.toggle();
         break;
      case 1: // Middle button clicked
         break;
      case 2: // Right button clicked
         break;
      default: //alert('Unexpected code: ' + btnCode);
   }
}

// ------------------------------------------------------------------------------------------------
// SecretAgent Context Menu/Context Area Menu Event Handler - used to handle context menu operations
function SecretAgentContextMenusOnPopupEventHandler(e) {
   dump("SecretAgent: Context popup event handler;\n");
   var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].
   getService(Components.interfaces.nsIPrefService);
   secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");

   if (secretAgentPreferences.getBoolPref("StealthMode")) {
      var label = SecretAgent.strings.getString("DisableStealthMode");
      document.getElementById("SecretAgent_context_menu_toggle").label = label;
      document.getElementById("SecretAgent_content_area_context_menu_toggle").label = label;
      document.getElementById("SecretAgent_context_menu_toggle").image = "chrome://SecretAgent/skin/icon16_red.png";
      document.getElementById("SecretAgent_content_area_context_menu_toggle").image = "chrome://SecretAgent/skin/icon16_red.png";
   } else {
      var label = SecretAgent.strings.getString("EnableStealthMode");
      document.getElementById("SecretAgent_context_menu_toggle").label = label;
      document.getElementById("SecretAgent_content_area_context_menu_toggle").label = label;
      document.getElementById("SecretAgent_context_menu_toggle").image = "chrome://SecretAgent/skin/icon16_green.png";
      document.getElementById("SecretAgent_content_area_context_menu_toggle").image = "chrome://SecretAgent/skin/icon16_green.png";
   }

   var domain = window.content.location.hostname;

   if (SecretAgent.isWhitelisted(domain)) {
      var pattern = SecretAgent.findWhitelistPattern(domain);
      var label = SecretAgent.strings.getFormattedString("RemoveFromWhitelist", [pattern]);
      document.getElementById("SecretAgent_context_menu_addtowhitelist").label = label;
      document.getElementById("SecretAgent_content_area_context_menu_addtowhitelist").label = label;
      document.getElementById("SecretAgent_context_menu_addtowhitelist").image = "chrome://SecretAgent/skin/flag_red.png";
      document.getElementById("SecretAgent_content_area_context_menu_addtowhitelist").image = "chrome://SecretAgent/skin/flag_red.png";
   } else {
      var label = SecretAgent.strings.getFormattedString("AddToWhitelist", [domain]);
      document.getElementById("SecretAgent_context_menu_addtowhitelist").label = label;
      document.getElementById("SecretAgent_content_area_context_menu_addtowhitelist").label = label;
      document.getElementById("SecretAgent_context_menu_addtowhitelist").image = "chrome://SecretAgent/skin/flag_white.png";
      document.getElementById("SecretAgent_content_area_context_menu_addtowhitelist").image = "chrome://SecretAgent/skin/flag_white.png";
   }
}

// ------------------------------------------------------------------------------------------------
// SecretAgent HTTP header visitor - used to debug header handling
var SecretAgentHttpHeaderVisitor = {
   visitHeader: function(header, value) {
      dump("SecretAgent: Header; " + header + ":" + value + "\n");
   }
};

// ------------------------------------------------------------------------------------------------
// SecretAgent HTTP Observer - Called as an http request is made. 

var SecretAgentHTTPObserver = {

      // ------------------------------------------------------------------------------------------------
      // Generate a random ETag
      RandomETag: function(length) {
         var chars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz_";
         var randomETag = '';
         for (var i = 0; i < length; i++) {
            var rnum = Math.floor(Math.random() * chars.length);
            randomETag += chars.substring(rnum, rnum + 1);
         }
         return randomETag;
      },

      // ------------------------------------------------------------------------------------------------
      // Observe HTTP requests
      observe: function(subject, topic, data) {
         var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
         secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");
         var generalUserAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
         generalUserAgentPreferences = generalUserAgentPreferences.getBranch("general.useragent.");
         var whitelistMode = false;

         // Request handling
         if (topic == "http-on-modify-request") {
            dump("SecretAgent: Request: http-on-modify-request;\n");
            var httpChannel = subject.QueryInterface(Components.interfaces.nsIHttpChannel);
            var domain = httpChannel.URI.host;
            dump("SecretAgent: Request: Processing [" + httpChannel.URI.spec + "];\n");

            // Dump http headers for debug
            // httpChannel.visitRequestHeaders( SecretAgentHttpHeaderVisitor );
            // ---------------------------

            if (secretAgentPreferences.getBoolPref("StealthMode")) {
               whitelistMode = SecretAgent.isWhitelisted(domain);
               if (whitelistMode) {
                  SecretAgent.updateGUIStatus("whitelist", domain);
                  dump("SecretAgent: Request: Whitelist actions;\n");
               } else /* Untrusted Domain */ {
                  SecretAgent.updateGUIStatus("stealth", domain);
                  dump("SecretAgent: Request: Stealth actions;\n");
               }

               if (secretAgentPreferences.getCharPref("EntropyLevel") == "request") {
                  SecretAgent.randomize();
               }

               this.setUserAgentRequestHeader(subject, whitelistMode);
               this.setOSCPUOverride(subject, whitelistMode);
               this.setAcceptRequestHeader(subject, whitelistMode);
               this.setETagRequestHeader(subject, whitelistMode);
               this.setViaRequestHeader(subject, whitelistMode);
               this.setForwardedForRequestHeader(subject, whitelistMode);

            }
         }

         // Response handling
         if (topic == "http-on-examine-response" || topic == "http-on-examine-cached-response" || topic == "http-on-examine-merged-response") {
            dump("SecretAgent: Response: " + topic + "\n");
            var httpChannel = subject.QueryInterface(Components.interfaces.nsIHttpChannel);
            var domain = httpChannel.URI.host;
            dump("SecretAgent: Response: Processing [" + httpChannel.URI.spec + "];\n");

            // Dump http headers for debug
            // httpChannel.visitResponseHeaders( SecretAgentHttpHeaderVisitor );
            // ---------------------------

            if (secretAgentPreferences.getBoolPref("StealthMode")) {
               whitelistMode = SecretAgent.isWhitelisted(domain);

               // Redirect Response handling
               if ((httpChannel.responseStatus == 301) || (httpChannel.responseStatus == 302) || (httpChannel.responseStatus == 303) || (httpChannel.responseStatus == 307)) {
                  if (this.isSuspectedHijack(subject)) {
                     this.showHijackRedirectAlert(subject, whitelistMode);
                     this.spikeHijackRedirect(subject, whitelistMode);
                  }
               }
               this.spoofDatestampResponseHeaders(subject, whitelistMode);
               this.spoofETagResponseHeaders(subject, whitelistMode);
            }
         }
      },

      // ------------------------------------------------------------------------------------------------
      // Set the User Agent Header in the request
      setUserAgentRequestHeader: function(subject, whitelistMode) {
         var httpChannel = subject.QueryInterface(Components.interfaces.nsIHttpChannel);
         var domain = httpChannel.URI.host;

         var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
         secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");
         var generalUserAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
         generalUserAgentPreferences = generalUserAgentPreferences.getBranch("general.useragent.");

         if (!secretAgentPreferences.getBoolPref("RotateUserAgent")) {
            return;
         }

         if (!secretAgentPreferences.getBoolPref("StealthMode")) {
            return;
         }

         if (whitelistMode) {
            dump("SecretAgent: Request: Whitelisting UA;\n");
            SecretAgent.clearGlobalUserAgentOverrides();
            SecretAgent.clearDomainSpecificUserAgentOverrides(domain);
            if (secretAgentPreferences.getCharPref("WhitelistUserAgentBehaviour") == "override") {
               var whitelistUserAgent = secretAgentPreferences.getCharPref("WhitelistUserAgent");
               dump("SecretAgent: Request: Setting Whitelist UA Overrides; " + whitelistUserAgent + "\n");
               generalUserAgentPreferences.setCharPref("override", whitelistUserAgent);
               generalUserAgentPreferences.setCharPref("override." + domain, whitelistUserAgent);
               httpChannel.setRequestHeader("User-Agent", whitelistUserAgent, false);

               SecretAgent.updateGUIStatus("whitelist", domain, whitelistUserAgent);
            } else {
               httpChannel.setRequestHeader("User-Agent", window.navigator.userAgent, false);

               SecretAgent.updateGUIStatus("whitelist", domain, window.navigator.userAgent);
            }
            return;
         }

         /* Untrusted Domain */
         dump("SecretAgent: Request: Setting UA Overrides; " + SecretAgent.randomUserAgent + "\n");
         generalUserAgentPreferences.setCharPref("override", SecretAgent.randomUserAgent);
         generalUserAgentPreferences.setCharPref("override." + domain, SecretAgent.randomUserAgent);
         httpChannel.setRequestHeader("User-Agent", SecretAgent.randomUserAgent, false);

         SecretAgent.updateGUIStatus("stealth", domain, SecretAgent.randomUserAgent);
      },

      // ------------------------------------------------------------------------------------------------
      // Set the OSCPU override
      setOSCPUOverride: function(subject, whitelistMode) {
         var httpChannel = subject.QueryInterface(Components.interfaces.nsIHttpChannel);
         var domain = httpChannel.URI.host;

         var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
         secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");
         var generalOSCPUPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
         generalOSCPUPreferences = generalOSCPUPreferences.getBranch("general.oscpu.");

         if (!secretAgentPreferences.getBoolPref("RotateOSCPU")) {
            return;
         }

         if (!secretAgentPreferences.getBoolPref("StealthMode")) {
            return;
         }

         if (whitelistMode) {
            dump("SecretAgent: Request: Whitelisting OSCPU;\n");
            SecretAgent.clearGlobalOSCPUOverrides();
            if (secretAgentPreferences.getCharPref("WhitelistOSCPUBehaviour") == "override") {
               var whitelistOSCPU = secretAgentPreferences.getCharPref("WhitelistOSCPU");
               dump("SecretAgent: Request: Setting Whitelist OSCPU Overrides; " + whitelistOSCPU + "\n");
               generalOSCPUPreferences.setCharPref("override", whitelistOSCPU);
            }
            return;
         }

         /* Untrusted Domain */
         dump("SecretAgent: Request: Setting OSCPU Overrides; " + SecretAgent.randomOSCPU + "\n");
         generalOSCPUPreferences.setCharPref("override", SecretAgent.randomOSCPU);

      },

      // ------------------------------------------------------------------------------------------------
      // Set the Accept Header in the request
      setAcceptRequestHeader: function(subject, whitelistMode) {
         var httpChannel = subject.QueryInterface(Components.interfaces.nsIHttpChannel);
         var domain = httpChannel.URI.host;

         var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
         secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");
         var networkHTTPAcceptPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
         networkHTTPAcceptPreferences = networkHTTPAcceptPreferences.getBranch("network.http.accept.");

         if (!secretAgentPreferences.getBoolPref("RotateAccept")) {
            return;
         }

         if (!secretAgentPreferences.getBoolPref("StealthMode")) {
            return;
         }

         if (whitelistMode) {
            dump("SecretAgent: Request: Whitelisting Accept;\n");
            SecretAgent.clearGlobalAcceptOverrides();
            if (secretAgentPreferences.getCharPref("WhitelistAcceptBehaviour") == "override") {
               var whitelistAccept = secretAgentPreferences.getCharPref("WhitelistAccept");
               dump("SecretAgent: Request: Setting Whitelist Accept Overrides; " + whitelistAccept + "\n");
               networkHTTPAcceptPreferences.setCharPref("default", whitelistAccept);
               httpChannel.setRequestHeader("Accept", whitelistAccept, false);
            } else {
               httpChannel.setRequestHeader("Accept", networkHTTPAcceptPreferences.getCharPref("default"), false);
            }
            return;
         }

         /* Untrusted Domain */
         dump("SecretAgent: Request: Rotating Accept; " + SecretAgent.randomAccept + "\n");
         networkHTTPAcceptPreferences.setCharPref("default", SecretAgent.randomAccept);
         httpChannel.setRequestHeader("Accept", SecretAgent.randomAccept, false);
      },

      // ------------------------------------------------------------------------------------------------
      // Set the ETag header in the request
      setETagRequestHeader: function(subject, whitelistMode) {
         var httpChannel = subject.QueryInterface(Components.interfaces.nsIHttpChannel);
         var domain = httpChannel.URI.host;

         var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
         secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");

         if (!secretAgentPreferences.getBoolPref("SpoofETags")) {
            return;
         }

         if (!secretAgentPreferences.getBoolPref("StealthMode")) {
            return;
         }

         if (whitelistMode) {
            /* no action */
            return;
         }

         /* Untrusted Domain */
         dump("SecretAgent: Request: Spoof eTags;\n");
         var ETag = '';
         var ETagLength = 0;
         try {
            dump("SecretAgent: Request: Finding request eTags;\n");
            ETag = httpChannel.getRequestHeader("If-None-Match");
            dump("SecretAgent: Request: ETag found in request;" + ETag + ". Overwriting ETag.\n");
            ETagLength = ETag.length;
            ETag = this.RandomETag(ETagLength);
         } catch (e) {
            dump("SecretAgent: Request: ETag not found in request, generating random ETag. Exception;" + e.message + "\n");
            ETagLength = Math.floor((Math.random() * 10) + 5);
            ETag = this.RandomETag(ETagLength);
         }
         dump("SecretAgent: Request: Spoofing ETag;" + ETag + "\n");
         httpChannel.setRequestHeader("If-None-Match", ETag, false);
      },

      // ------------------------------------------------------------------------------------------------
      // Set the Via header in the request
      setViaRequestHeader: function(subject, whitelistMode) {
         var httpChannel = subject.QueryInterface(Components.interfaces.nsIHttpChannel);
         var domain = httpChannel.URI.host;

         var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
         secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");

         if (!secretAgentPreferences.getBoolPref("SpoofVia")) {
            return;
         }

         if (!secretAgentPreferences.getBoolPref("StealthMode")) {
            return;
         }

         if (whitelistMode) {
            /* no action */
            return;
         }

         /* Untrusted Domain */
         dump("SecretAgent: Request: Spoofing VIA header;\n");
         httpChannel.setRequestHeader("Via", "1.1 " + SecretAgent.randomVia, false);
      },

      // ------------------------------------------------------------------------------------------------
      // Set the X-Forwarded-For header in the request
      setForwardedForRequestHeader: function(subject, whitelistMode) {
         var httpChannel = subject.QueryInterface(Components.interfaces.nsIHttpChannel);
         var domain = httpChannel.URI.host;

         var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
         secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");

         if (!secretAgentPreferences.getBoolPref("SpoofForwardedFor")) {
            return;
         }

         if (!secretAgentPreferences.getBoolPref("StealthMode")) {
            return;
         }

         if (whitelistMode) {
            /* no action */
            return;
         }

         /* Untrusted Domain */
         dump("SecretAgent: Request: Spoofing X-Forwarded-For header;\n");
         httpChannel.setRequestHeader("X-Forwarded-For", SecretAgent.randomForwardedFor, false);
      },

      // ------------------------------------------------------------------------------------------------
      // Show Hijacked Redirect Alert
      showHijackRedirectAlert: function(subject, whitelistMode) {
         var httpChannel = subject.QueryInterface(Components.interfaces.nsIHttpChannel);
         var domain = httpChannel.URI.host;
         var redirectLocation = httpChannel.getResponseHeader("Location");
         var redirectHost = this.getHostFromRedirectURL(redirectLocation, httpChannel.URI.host);

         var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
         secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");

         if (!secretAgentPreferences.getBoolPref("ShowHijackRedirectAlerts")) {
            return;
         }

         if (!secretAgentPreferences.getBoolPref("StealthMode")) {
            return;
         }

         if (whitelistMode && !secretAgentPreferences.getBoolPref("WhitelistHijackDetection")) {
            /* no action */
            return;
         }

         /* Untrusted Domain and untrusted redirect */
         var sourceURI = "";
         if (subject.URI.spec.length>80)
         {
            sourceURI =  subject.URI.spec.slice(0,39) + "..." + subject.URI.spec.slice(-40);
         }
         else
         {
            sourceURI =  subject.URI.spec;
         }
         var destinationURI = "";
         if (redirectLocation.length>80)
         {
            destinationURI =  redirectLocation.slice(0,39) + "..." + redirectLocation.slice(-40);
         }
         else
         {
            destinationURI = redirectLocation;
         }

         var HijackWarning = SecretAgent.strings.getString("Warning_HijackedRequest") + "\n\n" + SecretAgent.strings.getString("Warning_Surveillance") + "\n\n" + sourceURI + " " + SecretAgent.strings.getString("Warning_RedirectedTo") + " " + destinationURI + "\n" + SecretAgent.strings.getString("Warning_UsingA") + " " + httpChannel.responseStatus + " " + SecretAgent.strings.getString("Warning_RedirectMessage"); 
         
         var ShortHijackWarning = SecretAgent.strings.getString("Warning_HijackDetected");
         //var ReportHijackWarning = SecretAgent.strings.getString("Warning_HijackedRequest") + " " + sourceURI + " " + SecretAgent.strings.getString("Warning_RedirectedTo") + " " + destinationURI + " " + SecretAgent.strings.getString("Warning_UsingA") + " " + httpChannel.responseStatus + " " +  SecretAgent.strings.getString("Warning_RedirectMessage");

         dump("SecretAgent: Response: Showing Hijack Warnings\n");
         try {
            var notificationBox = gBrowser.getNotificationBox();
            var details = domain + " " + redirectHost;
            notificationBox.appendNotification(HijackWarning, details, "chrome://SecretAgent/skin/icon16_yellow.gif", notificationBox.PRIORITY_WARNING_MEDIUM, null);
         } catch (err) {
            // ignore, support for alerts in Firefox is a bit erratic
         }
         if (!SecretAgent.alertShownFlag) {
            try {
               var alertsService = Components.classes["@mozilla.org/alerts-service;1"]
                  .getService(Components.interfaces.nsIAlertsService);
               alertsService.showAlertNotification("chrome://SecretAgent/skin/icon16_yellow.gif", "Secret Agent", ShortHijackWarning);
            } catch (err) {
               alert(HijackWarning);
            }
            SecretAgent.alertShownFlag = true;
         }
      },

      // ------------------------------------------------------------------------------------------------
      // Override the location header in a redirect reponse
      spikeHijackRedirect: function(subject, whitelistMode) {
         var httpChannel = subject.QueryInterface(Components.interfaces.nsIHttpChannel);
         var domain = httpChannel.URI.host;
         var redirectLocation = httpChannel.getResponseHeader("Location");
         var redirectHost = this.getHostFromRedirectURL(redirectLocation, httpChannel.URI.host);

         var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
         secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");

         if (!secretAgentPreferences.getBoolPref("SpikeHijackRedirects")) {
            return;
         }

         if (!secretAgentPreferences.getBoolPref("StealthMode")) {
            return;
         }

         if (whitelistMode && !secretAgentPreferences.getBoolPref("WhitelistHijackDetection")) {
            /* no action */
            return;
         }

         /* Untrusted Domain and untrusted redirect */
         var spikeRedirectLocation = secretAgentPreferences.getCharPref("SpikeHijackRedirectLocation");

         // spike the redirect
         dump("SecretAgent: Response: Spiking Hijack\n");

         httpChannel.setResponseHeader("Location", spikeRedirectLocation, false);

         if (secretAgentPreferences.getBoolPref("ShowSpikeHijackRedirectAlerts")) {
            var SpikeWarning = SecretAgent.strings.getString("Warning_SpikedHijackedRequest") + "\n\n" + SecretAgent.strings.getString("Warning_Surveillance") + "\n\n" + subject.URI.spec + " " + SecretAgent.strings.getString("Warning_RedirectedTo") + " " + redirectLocation + "\n" + SecretAgent.strings.getString("Warning_UsingA") + " " + httpChannel.responseStatus + " " + SecretAgent.strings.getString("Warning_RedirectMessage");
            var ShortSpikeWarning = SecretAgent.strings.getString("Warning_HijackSpiked");
            //var ReportSpikeWarning = SecretAgent.strings.getString("Warning_SpikedHijackedRequest") + " "  + subject.URI.spec + " " + SecretAgent.strings.getString("Warning_RedirectedTo") + " " + redirectLocation + " " + SecretAgent.strings.getString("Warning_UsingA") + " " + httpChannel.responseStatus + " " +  SecretAgent.strings.getString("Warning_RedirectMessage");

            try {
               var notificationBox = gBrowser.getNotificationBox();
               notificationBox.appendNotification(SpikeWarning, "SecretAgentWarning", "chrome://SecretAgent/skin/icon16_yellow.gif", notificationBox.PRIORITY_WARNING_MEDIUM, null);
            } catch (err) {
               // ignore, support for alerts in Firefox is a bit erratic
            }
            if (!SecretAgent.alertShownFlag) {
               try {
                  var alertsService = Components.classes["@mozilla.org/alerts-service;1"]
                     .getService(Components.interfaces.nsIAlertsService);
                  alertsService.showAlertNotification("chrome://SecretAgent/skin/icon16_yellow.gif", "Secret Agent", ShortSpikeWarning);
               } catch (err) {
                  // do nothing
               }
               SecretAgent.alertShownFlag = true;
            }
         }
      },

      // ------------------------------------------------------------------------------------------------
      // Spoof Datestamp headers in the response
      spoofDatestampResponseHeaders: function(subject, whitelistMode) {
         var httpChannel = subject.QueryInterface(Components.interfaces.nsIHttpChannel);
         var domain = httpChannel.URI.host;

         var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
         secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");

         if (!secretAgentPreferences.getBoolPref("SpoofDatestamps")) {
            return;
         }

         if (!secretAgentPreferences.getBoolPref("StealthMode")) {
            return;
         }

         if (whitelistMode) {
            /* no action */
            return;
         }

         /* Untrusted Domain */
         dump("SecretAgent: Response: Spoof Datestamps;\n");
         try {
            dump("SecretAgent: Response: Finding Datestamps;\n");
            var dateStamp = new Date(httpChannel.getResponseHeader("Last-Modified"));
            dump("SecretAgent: Response: DateStamps found;" + dateStamp.toUTCString() + "\n");
            dateStamp = new Date(dateStamp.getTime() - Math.floor(Math.random() * 24 * 60 * 60 * 1000));
            dump("SecretAgent: Response: Spoofing DateStamp;" + dateStamp.toUTCString() + "\n");
            httpChannel.setResponseHeader("Last-Modified", dateStamp.toUTCString(), false);
         } catch (e) {
            dump("SecretAgent: Response: Exception;" + e.message + "\n");
         }
      },

      // ------------------------------------------------------------------------------------------------
      // Spoof eTag headers in the response
      spoofETagResponseHeaders: function(subject, whitelistMode) {
         var httpChannel = subject.QueryInterface(Components.interfaces.nsIHttpChannel);
         var domain = httpChannel.URI.host;

         var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
         secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");

         if (!secretAgentPreferences.getBoolPref("SpoofETags")) {
            return;
         }

         if (!secretAgentPreferences.getBoolPref("StealthMode")) {
            return;
         }

         if (whitelistMode) {
            /* no action */
            return;
         }

         /* Untrusted Domain */
         dump("SecretAgent: Response: Spoof eTags;\n");
         try {
            dump("SecretAgent: Response: Finding eTags in response;\n");
            var ETag = httpChannel.getResponseHeader("ETag");
            dump("SecretAgent: Response: ETag found in response;" + ETag + ". Overwriting ETag.\n");
            //		   		   var ETagLength = Math.floor((Math.random()*10)+5); 
            var ETagLength = ETag.length;
            ETag = this.RandomETag(ETagLength);
            dump("SecretAgent: Response: Spoofing ETag;" + ETag + "\n");
            httpChannel.setResponseHeader("ETag", ETag, false);
         } catch (e) {
            dump("SecretAgent: Response: ETag not found in response. Exception;" + e.message + "\n");
         }
      },

      // ------------------------------------------------------------------------------------------------
      enable: function() {
         // Add HTTP Observer
         var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);

         try {
            observerService.addObserver(SecretAgentHTTPObserver, "http-on-modify-request", false);
            observerService.addObserver(SecretAgentHTTPObserver, "http-on-examine-response", false);
            observerService.addObserver(SecretAgentHTTPObserver, "http-on-examine-cached-response", false);
            observerService.addObserver(SecretAgentHTTPObserver, "http-on-examine-merged-response", false);
         } catch (err) {
            dump(err.message);
         }
      },

      // ------------------------------------------------------------------------------------------------
      disable: function() {
         // Remove HTTP Observer
         var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);

         try {
            observerService.removeObserver(SecretAgentHTTPObserver, "http-on-modify-request");
            observerService.removeObserver(SecretAgentHTTPObserver, "http-on-examine-response");
         } catch (err) {
            dump(err.message);
         }
      },

      // ------------------------------------------------------------------------------------------------
      // decompose a redirect url to find the host, or return origin if url is relative
      getHostFromRedirectURL: function(redirectUrl, originHost) {
         var host;
         // Expected Common Internet Scheme Syntax 
         // scheme://<user>:<password>@<host>:<port>/<url-path

         // is this a relative or absolute URL
         if (redirectUrl.indexOf("//", 0) > -1) {
            // ABSOLUTE URL
            // Remove scheme:// (generally http:// or https://)
            host = redirectUrl.substr(redirectUrl.indexOf("//", 0) + 2);
            // Remove the path after the first / if present
            if (host.indexOf("/", 0) > -1)
               host = host.slice(0, host.indexOf("/", 0));
            // Remove the path after the first ? if present
            if (host.indexOf("?", 0) > -1)
               host = host.slice(0, host.indexOf("?", 0));
            // Remove user:password@ if present
            if (host.indexOf("@", 0) > -1)
               host = host.substr(host.indexOf("@", 0) + 1);
            // Remove :port if present
            if (host.indexOf(":", 0) > -1)
               host = host.slice(0, host.indexOf(":", 0));
         } else {
            // RELATIVE URL
            host = originHost;
         }
         return host;
      },

      // ------------------------------------------------------------------------------------------------
      // check for a suspected hijack & reirect to anther domain
      isSuspectedHijack: function(subject) {
         var httpChannel = subject.QueryInterface(Components.interfaces.nsIHttpChannel);
         var domain = httpChannel.URI.host;
         var redirectLocation = httpChannel.getResponseHeader("Location");
         var redirectHost = this.getHostFromRedirectURL(redirectLocation, httpChannel.URI.host);

         var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
         secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");
         var spikeRedirectLocation = secretAgentPreferences.getCharPref("SpikeHijackRedirectLocation");

         dump("SecretAgent: Response: Analysing redirect ");

         dump("from " + httpChannel.URI.host + " to " + redirectHost + "\n");
         // If the original URL and redirect url don't match... and its not spiked or whitelisted... suspect hijack
         if (!(domain == redirectHost) && !(redirectLocation == spikeRedirectLocation)) {
            dump("SecretAgent: Response: Hijack Detected!");
            return true;
         }

         return false;
      },

}


// ------------------------------------------------------------------------------------------------
      // SecretAgent Add On - the work horse of the browser add on. 

      var SecretAgent = {

         alertShownFlag: false,
         randomUserAgent: "uninitialised",
         randomOSCPU: "uninitialised",
         randomAccept: "uninitialised",
         randomVia: "uninitialised",
         randomForwardedFor: "uninitialised",

         //----------------------------------------------------------------------------------------------------
         init: function() {
            dump("SecretAgent: initialising\n");
            // Get the "extensions.SecretAgent." branch
            var preferences = Components.classes["@mozilla.org/preferences-service;1"].
            getService(Components.interfaces.nsIPrefService);
            preferences = preferences.getBranch("extensions.SecretAgent.");

            this.strings = document.getElementById("SecretAgent-strings");

            if (preferences.getBoolPref("showStartupAlert")) {
               dump("SecretAgent: SecretAgent displaying splash screen");
               window.openDialog("chrome://SecretAgent/content/splash.xul", "SecretAgent Installed", "centerscreen, chrome, toolbar, modal");
            }

            // Initialise Agents
            SecretAgent.initialiseUserAgentList();

            // Initialise Accept Headers
            SecretAgent.initialiseAcceptList();

            // Initialise OSCPU strings
            SecretAgent.initialiseOSCPUList();

            // Initialise Whitelist
            SecretAgent.initialiseWhitelist();

            // Add http observer
            dump("SecretAgent: enabling HTTP observer\n");
            SecretAgentHTTPObserver.enable();

            // Set status bar
            SecretAgent.updateGUIStatus();

            var appcontent = document.getElementById("appcontent"); // browser
            if (appcontent) {
               dump("SecretAgent: browser - adding pageload listeners\n");
               appcontent.addEventListener("DOMContentLoaded", this.onPageLoad, true);
            }

            // Initialize random headers

            SecretAgent.randomize();

            dump("SecretAgent: HTTP User Agent rotation loaded!\n");

         },

         //----------------------------------------------------------------------------------------------------
         uninit: function() {
            dump("SecretAgent: uninitialising\n");

            dump("SecretAgent: removing http observer\n");

            // Remove http listener
            SecretAgentHTTPObserver.disable();

            // Tidy up overrides
            var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].
            getService(Components.interfaces.nsIPrefService);
            secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");

            if (secretAgentPreferences.getBoolPref("RotateUserAgent")) {
               SecretAgent.clearGlobalUserAgentOverrides();
               SecretAgent.clearAllDomainSpecificUserAgentOverrides();
            }
            if (secretAgentPreferences.getBoolPref("RotateOSCPU")) {
               SecretAgent.clearGlobalOSCPUOverrides();
            }
         },

         // ------------------------------------------------------------------------------------------------
         // Set the text in the status bar panel and toolbar icons
         updateGUIStatus: function(status, domain, useragent) {
            var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].
            getService(Components.interfaces.nsIPrefService);
            secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");

            var label = "uninitialised";
            var image = "uninitialised";
            var tooltiptext = "uninitialised";
            var style = "uninitialised";

            if (arguments.length > 0 && status == "whitelist") {
               label = SecretAgent.strings.getString("Whitelist");
               image = "chrome://SecretAgent/skin/icon16_yellow.gif";
               tooltiptext = SecretAgent.strings.getString("SecretAgentDetectedAWhitelistedSite");
               style = "color:#a69700; font-weight:bold;";
               document.getElementById("SecretAgent_content_area_context_menuitem").image = "chrome://SecretAgent/skin/icon16.png";
            } else if (secretAgentPreferences.getBoolPref("StealthMode")) {
               label = SecretAgent.strings.getString("Stealth");
               if (secretAgentPreferences.getCharPref("EntropyLevel") == "session") {
                  label += " (" + SecretAgent.strings.getString("Session") + ")";
               } else if (secretAgentPreferences.getCharPref("EntropyLevel") == "page") {
                  label += " (" + SecretAgent.strings.getString("Page") + ")";
               }
               image = "chrome://SecretAgent/skin/icon16_green.gif";
               tooltiptext = SecretAgent.strings.getString("SecretAgentIsModifyingHTTPRequests");
               style = "color:#00a600; font-weight:bold;";
               document.getElementById("SecretAgent_content_area_context_menuitem").image = "chrome://SecretAgent/skin/icon16.png";
            } else {
               label = SecretAgent.strings.getString("Default");
               image = "chrome://SecretAgent/skin/icon16_red.gif";
               tooltiptext = SecretAgent.strings.getString("SecretAgentIsNotModifyingHTTPRequests");
               style = "color:#a60000; font-weight:bold;";
               document.getElementById("SecretAgent_content_area_context_menuitem").image = "chrome://SecretAgent/skin/icon16_red.png";
            }

            if (arguments.length > 1) {
               tooltiptext = tooltiptext + " (" + domain + ")";
            }

            if (arguments.length > 2) {
               tooltiptext = tooltiptext + "\n\n" + SecretAgent.strings.getString("LastUserAgent") + ": " + useragent;
            }

            // Set the status bar message
            try {
               var SecretAgent_statusbarpanel = document.getElementById("SecretAgent_statusbarpanel");
               SecretAgent_statusbarpanel.image = "chrome://SecretAgent/skin/icon16.png";
               SecretAgent_statusbarpanel.image = image;
               SecretAgent_statusbarpanel.label = label;
               SecretAgent_statusbarpanel.setAttribute("tooltiptext", tooltiptext);
               SecretAgent_statusbarpanel.setAttribute("style", style);
            } catch (e) {
               dump("SecretAgent: updateGUIStatus: Can't set Secret Agent status bar panel status. No Secret Agent status bar panel? Exception;" + e.message + "\n");
            }

            // Copy status to toolbarbutton
            try {
               var SecretAgent_toolbarbutton = document.getElementById("SecretAgent_toolbarbutton");
               SecretAgent_toolbarbutton.image = "chrome://SecretAgent/skin/icon16.png";
               SecretAgent_toolbarbutton.image = image;
               SecretAgent_toolbarbutton.label = label;
               SecretAgent_toolbarbutton.setAttribute("tooltiptext", tooltiptext);
               SecretAgent_toolbarbutton.setAttribute("style", style);
               SecretAgent_toolbarbutton.setAttribute("image", image); //seamonkey workaround
               SecretAgent_toolbarbutton.setAttribute("label", label); //seamonkey workaround
            } catch (e) {
               dump("SecretAgent: updateGUIStatus: Can't set Secret Agent toolbar bar button status. No Secret Agent toolbar button? Exception;" + e.message + "\n");
            }
         },

         // ------------------------------------------------------------------------------------------------
         // Toggle On/Off
         toggle: function() {

            var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].
            getService(Components.interfaces.nsIPrefService);
            secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");

            // Toggle Status and Set the status  message
            if (secretAgentPreferences.getBoolPref("StealthMode")) {
               SecretAgent.off();
            } else {
               SecretAgent.on();
            }

         },

         // ------------------------------------------------------------------------------------------------
         // Initialise agents
         initialiseUserAgentList: function() {
            var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].
            getService(Components.interfaces.nsIPrefService);
            secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");

            SecretAgent['UserAgentList'] = secretAgentPreferences.getCharPref("UserAgentList").split("\n");
         },

         // ------------------------------------------------------------------------------------------------
         // Initialise accept headers
         initialiseAcceptList: function() {
            var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].
            getService(Components.interfaces.nsIPrefService);
            secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");

            SecretAgent['AcceptList'] = secretAgentPreferences.getCharPref("AcceptList").split("\n");
         },

         // ------------------------------------------------------------------------------------------------
         // Initialise OSCPU strings
         initialiseOSCPUList: function() {
            var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].
            getService(Components.interfaces.nsIPrefService);
            secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");

            SecretAgent['OSCPUList'] = secretAgentPreferences.getCharPref("OSCPUList").split("\n");
         },

         // ------------------------------------------------------------------------------------------------
         // Initialise whitelist
         initialiseWhitelist: function() {
            var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].
            getService(Components.interfaces.nsIPrefService);
            secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");

            var whitelist = secretAgentPreferences.getCharPref("Whitelist");
            var WhitelistSimplePatterns = new Array();

            WhitelistSimplePatterns = whitelist.split("\n");

            SecretAgent['WhitelistSimplePatterns'] = new Array();
            SecretAgent['WhitelistRegExps'] = new Array();

            for (var i = 0; i < WhitelistSimplePatterns.length; i++) {
               var pattern = WhitelistSimplePatterns[i];
               if (pattern.length > 0) // skip blank lines
               {
                  SecretAgent['WhitelistSimplePatterns'].push(pattern);
                  pattern = pattern.replace(/[\\]/g, "\\\\");
                  pattern = pattern.replace(/[\^]/g, "\\^");
                  pattern = pattern.replace(/[$]/g, "\\$");
                  pattern = pattern.replace(/[.]/g, "\\.");
                  pattern = pattern.replace(/[|]/g, "\\|");
                  pattern = pattern.replace(/[(]/g, "\\(");
                  pattern = pattern.replace(/[)]/g, "\\)");
                  pattern = pattern.replace(/[[]/g, "\\[");
                  pattern = pattern.replace(/[{]/g, "\\{");
                  pattern = pattern.replace(/[+]/g, "\\+");
                  // wildcard characters
                  pattern = pattern.replace(/[*]/g, "(.*)"); // convert * to be a regexp group
                  pattern = pattern.replace(/[?]/g, "(.)"); // convert ? to be a regexp group
                  pattern = "^" + pattern + "$"; // restrict to be a whole line match
                  SecretAgent['WhitelistRegExps'].push(new RegExp(pattern, "i"));
               }
            }

            dump("SecretAgent: Whitelist simple patterns list;\n");
            dump(SecretAgent['WhitelistSimplePatterns']);
            dump("\n");
            dump("SecretAgent: Whitelist regular expressions list;\n");
            dump(SecretAgent['WhitelistRegExps']);
            dump("\n");
         },

         // ------------------------------------------------------------------------------------------------
         // Is whitelisted?
         isWhitelisted: function(domain) {
            var whitelisted = SecretAgent.WhitelistRegExps.some(function(regexp) {
               return regexp.test(domain);
            });
            dump("SecretAgent: Domain whitelist check for " + domain + " returning " + whitelisted);
            dump("\n");

            return whitelisted;

         },

         // ------------------------------------------------------------------------------------------------
         // Toggle whitelist entry
         toggleWhitelist: function(domain) {

            if (SecretAgent.isWhitelisted(domain)) {
               var pattern = SecretAgent.findWhitelistPattern(domain);
               SecretAgent.removePatternFromWhitelist(pattern);
            } else {
               SecretAgent.addPatternToWhitelist(domain);
            }

         },

         // ------------------------------------------------------------------------------------------------
         // Add domain pattern to whitelist
         addPatternToWhitelist: function(pattern) {
            var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].
            getService(Components.interfaces.nsIPrefService);
            secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");

            var oldWhitelist = secretAgentPreferences.getCharPref("Whitelist");

            // Already in the list
            if (oldWhitelist.indexOf(pattern) > -1) return;

            var newWhitelistSimplePatterns = new Array();
            newWhitelistSimplePatterns = oldWhitelist.split("\n");
            newWhitelistSimplePatterns.unshift(pattern);
            var newWhitelist = newWhitelistSimplePatterns.toString();
            newWhitelist = newWhitelist.replace(/,/g, "\n");

            secretAgentPreferences.setCharPref("Whitelist", newWhitelist);

            SecretAgent.initialiseWhitelist();

         },

         // ------------------------------------------------------------------------------------------------
         // Remove domain pattern from whitelist
         removePatternFromWhitelist: function(pattern) {
            var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].
            getService(Components.interfaces.nsIPrefService);
            secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");

            var oldWhitelist = secretAgentPreferences.getCharPref("Whitelist");

            // Already removed from the list
            if (oldWhitelist.indexOf(pattern) < 0) return;

            var newWhitelistSimplePatterns = new Array();
            newWhitelistSimplePatterns = oldWhitelist.split("\n");
            newWhitelistSimplePatterns.splice(newWhitelistSimplePatterns.indexOf(pattern), 1);
            var newWhitelist = newWhitelistSimplePatterns.toString();
            newWhitelist = newWhitelist.replace(/,/g, "\n");

            secretAgentPreferences.setCharPref("Whitelist", newWhitelist);

            SecretAgent.initialiseWhitelist();

         },

         // ------------------------------------------------------------------------------------------------
         // Find the first whitelist pattern matching the domain
         findWhitelistPattern: function(domain) {
            var pattern = domain;
            dump("SecretAgent: FindWhitelistPattern; for " + pattern + "\n");
            for (var i = 0; i < SecretAgent.WhitelistRegExps.length && pattern == domain; i++) {
               if (SecretAgent.WhitelistRegExps[i].test(domain)) {
                  pattern = SecretAgent.WhitelistSimplePatterns[i];
               }
            }
            dump("SecretAgent: FindWhitelistPattern; returning " + pattern + "\n");
            return pattern;
         },

         // ------------------------------------------------------------------------------------------------
         // on
         on: function() {
            var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].
            getService(Components.interfaces.nsIPrefService);
            secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");

            // Start randomising the User Agent
            secretAgentPreferences.setBoolPref("StealthMode", true);

            SecretAgent.updateGUIStatus();

         },

         // ------------------------------------------------------------------------------------------------
         // off
         off: function() {

            var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].
            getService(Components.interfaces.nsIPrefService);
            secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");

            secretAgentPreferences.setBoolPref("StealthMode", false);

            // Stop randomising the User Agent
            if (secretAgentPreferences.getBoolPref("RotateUserAgent")) {
               SecretAgent.clearGlobalUserAgentOverrides();
               SecretAgent.clearAllDomainSpecificUserAgentOverrides();
            }
            if (secretAgentPreferences.getBoolPref("RotateOSCPU")) {
               SecretAgent.clearGlobalOSCPUOverrides();
            }
            if (secretAgentPreferences.getBoolPref("RotateAccept")) {
               SecretAgent.clearGlobalAcceptOverrides();
            }

            // Refresh the Status Bar
            SecretAgent.updateGUIStatus();

         },

         //----------------------------------------------------------------------------------------------------
         // restore default user agent override preferences for all domains
         clearGlobalUserAgentOverrides: function() {

            // Remove general.useragent.override
            var generalUserAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
            generalUserAgentPreferences = generalUserAgentPreferences.getBranch("general.useragent.");

            try {
               generalUserAgentPreferences.clearUserPref("override");
            } catch (e) {
               dump("SecretAgent: Exception;" + e.message + "\n");
            }

         },

         //----------------------------------------------------------------------------------------------------
         // restore default oscpu override preferences for all domains
         clearGlobalOSCPUOverrides: function() {

            // Remove general.oscpu.override
            var generalOSCPUPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
            generalOSCPUPreferences = generalOSCPUPreferences.getBranch("general.oscpu.");

            try {
               generalOSCPUPreferences.clearUserPref("override");
            } catch (e) {
               dump("SecretAgent: Exception;" + e.message + "\n");
            }

         },

         //----------------------------------------------------------------------------------------------------
         // restore default accept override preferences for all domains
         clearGlobalAcceptOverrides: function() {

            // Remove network.http.accept.default
            var networkHTTPAcceptPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
            networkHTTPAcceptPreferences = networkHTTPAcceptPreferences.getBranch("network.http.accept.");

            try {
               networkHTTPAcceptPreferences.clearUserPref("default");
            } catch (e) {
               dump("SecretAgent: Exception;" + e.message + "\n");
            }

         },

         //----------------------------------------------------------------------------------------------------
         // restore default user agent preferences for all domains
         clearAllDomainSpecificUserAgentOverrides: function() {

            var generalUserAgentOverridePreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
            generalUserAgentOverridePreferences = generalUserAgentOverridePreferences.getBranch("general.useragent.override.");

            // Remove general.useragent.override.*
            generalUserAgentOverridePreferences.getChildList('', {}).forEach(SecretAgent.clearDomainSpecificUserAgentOverrides);

            try {
               generalUserAgentOverridePreferences.deleteBranch("");
            } catch (e) {
               dump("SecretAgent: Exception;" + e.message + "\n");
            }

         },

         //----------------------------------------------------------------------------------------------------
         // restore default user agent preferences for a given domain
         clearDomainSpecificUserAgentOverrides: function(domain) {

            var generalUserAgentOverridePreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
            generalUserAgentOverridePreferences = generalUserAgentOverridePreferences.getBranch("general.useragent.override.");

            // Remove general.useragent.override.<domain>
            // This may leave some third party overrides in place, these are cleared on exit
            try {
               generalUserAgentOverridePreferences.clearUserPref(domain);
            } catch (e) {
               dump("SecretAgent: Exception;" + e.message + "\n");
            }

         },

         //----------------------------------------------------------------------------------------------------
         onPageLoad: function(e) {
            // add event listener for page unload 
            dump("SecretAgent: onpageload\n");
            e.originalTarget.defaultView.addEventListener("unload", function(event) {
               SecretAgent.onPageUnload(event);
            }, true);

            SecretAgent.alertShownFlag = false;

            var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].
            getService(Components.interfaces.nsIPrefService);
            secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");

            if (secretAgentPreferences.getCharPref("EntropyLevel") == "page") {
               SecretAgent.randomize();
            }
         },

         //----------------------------------------------------------------------------------------------------
         onPageUnload: function(e) {

            var domain = e.originalTarget.domain; // document domain that triggered "onload" event

            // Remove the override for this domain. This may leave some third party overrides in place, so we clear all residual overrides afterward
            // Removing this value avoids generating a list in the preferences settings of every domain visited
            SecretAgent.clearDomainSpecificUserAgentOverrides(domain);

         },

         randomize: function() {
            dump("SecretAgent: randomizing\n");
            SecretAgent.randomUserAgent = SecretAgent.UserAgentList[Math.floor(Math.random() * SecretAgent.UserAgentList.length)];
            SecretAgent.randomOSCPU = SecretAgent.OSCPUList[Math.floor(Math.random() * SecretAgent.OSCPUList.length)];
            SecretAgent.randomAccept = SecretAgent.AcceptList[Math.floor(Math.random() * SecretAgent.AcceptList.length)];
            var a = (1 + Math.floor(Math.random() * 254));
            var b = (1 + Math.floor(Math.random() * 254));
            var c = (1 + Math.floor(Math.random() * 254));
            var d = (1 + Math.floor(Math.random() * 254));
            SecretAgent.randomVia = a + "." + b + "." + c + "." + d;
            var a = (1 + Math.floor(Math.random() * 254));
            var b = (1 + Math.floor(Math.random() * 254));
            var c = (1 + Math.floor(Math.random() * 254));
            var d = (1 + Math.floor(Math.random() * 254));
            SecretAgent.randomForwardedFor = a + "." + b + "." + c + "." + d;
         }
      }