"use strict";
//SecretAgent
// 
//Licence Terms
// 
//1) SecretAgent is copyright Peter John
//
//You may;
//
//2) Download and install SecretAgent software for personal or commercial use
//
//3) You may use SecretAgent software on as many computers as you wish, without charge
//
//4) You may decompile the software, but only to verify the code will perform to specification
//
//You may not;
//
//5) Rebrand or bundle the code, or any part of the code, with any other software product
//
//6) Incorporate the code into a product or service involving Phorm or any other advertising system
//
//Specific Restrictions;
//
//7) SecretAgent software is not licenced for use by employees or sub-contractors working for Phorm, BT, Plusnet, TalkTalk, Virgin, Vodafone, BBC, News Corporation, News International, Logica, Experian, Verizon, Facebook, Schillings, Berenberg, Blackrock, Dartley Bank
//
//8) SecretAgent software is not licenced for use by employees or sub-contractors working for UK Central Government (including but not limited to the Information Commissioners Office, Home Office, Ministry of Justice, Dept for Business Innovation and Skills, Cabinet Office, Ministry of Defence, Foreign Office, Department for Education).
//
//9) SecretAgent software is not licenced for use by employees or sub-contractors working for UK Police forces
// 

function populatePreferences() {

   const nsIPrefService = Components.interfaces.nsIPrefService;

   var browserPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
   var generalUserAgentPreferences = browserPreferences.getBranch("general.useragent.");
   var generalOSCPUPreferences = browserPreferences.getBranch("general.oscpu.");
   var networkHTTPAcceptPreferences = browserPreferences.getBranch("network.http.accept.");

   clearAllOverrides();

   var txtDefaultUserAgent = document.getElementById("txtDefaultUserAgent");
   if (generalUserAgentPreferences.prefHasUserValue("override"))
   {
      txtDefaultUserAgent.value=generalUserAgentPreferences.getCharPref("override");
   }
   else
   {
      txtDefaultUserAgent.value=navigator.userAgent;
   }

   var txtDefaultOSCPU = document.getElementById("txtDefaultOSCPU");
   if (generalOSCPUPreferences.prefHasUserValue("override"))
   {
      txtDefaultOSCPU.value=generalOSCPUPreferences.getCharPref("override");
   }
   else
   {
      txtDefaultOSCPU.value=navigator.oscpu;
   }
   
   var txtDefaultAccept = document.getElementById("txtDefaultAccept");
   txtDefaultAccept.value=networkHTTPAcceptPreferences.getCharPref("default");

   var c1 = document.getElementById("checkDisableGeoLocation");
   var c2 = document.getElementById("checkEnableGeoLocation");
   c1.checked = ! c2.checked;
   document.getElementById('checkDisableGeoLocation').addEventListener('CheckboxStateChange', function(){
	  var c = document.getElementById("checkEnableGeoLocation");
	  c.click();
   });
   
   var c3 = document.getElementById("checkDisableKeywordSearch");
   var c4 = document.getElementById("checkEnableKeywordSearch");
   c3.checked = ! c4.checked;
   document.getElementById('checkDisableKeywordSearch').addEventListener('CheckboxStateChange', function(){
	  var c = document.getElementById("checkEnableKeywordSearch");
	  c.click();
   });
   
   var c5 = document.getElementById("checkDisableGetAddonsCache");
   var c6 = document.getElementById("checkEnableGetAddonsCache");
   c5.checked = ! c6.checked;
   document.getElementById('checkDisableGetAddonsCache').addEventListener('CheckboxStateChange', function(){
	  var c = document.getElementById("checkEnableGetAddonsCache");
	  c.click();
   });
   
   var c7 = document.getElementById("checkDisableNetworkPrefetch");
   var c8 = document.getElementById("checkEnableNetworkPrefetch");
   c7.checked = ! c8.checked;
   document.getElementById('checkDisableNetworkPrefetch').addEventListener('CheckboxStateChange', function(){
	  var c = document.getElementById("checkEnableNetworkPrefetch");
	  c.click();
   });
   
   var c9  = document.getElementById("checkDisableWebRTC");
   var c10 = document.getElementById("checkEnableWebRTC");
   c9.checked = ! c10.checked;
   document.getElementById('checkDisableWebRTC').addEventListener('CheckboxStateChange', function(){
	  var c = document.getElementById("checkEnableWebRTC");
	  c.click();
   });

   var c11 = document.getElementById("checkDisableBrowserCasting");
   var c12 = document.getElementById("checkEnableBrowserCasting");
   c11.checked = ! c12.checked;
   document.getElementById('checkDisableBrowserCasting').addEventListener('CheckboxStateChange', function(){
	  var c = document.getElementById("checkEnableBrowserCasting");
	  c.click();
   });

   var c13 = document.getElementById("checkDisableBeacon");
   var c14 = document.getElementById("checkEnableBeacon");
   c13.checked = ! c14.checked;
   document.getElementById('checkDisableBeacon').addEventListener('CheckboxStateChange', function(){
	  var c = document.getElementById("checkEnableBeacon");
	  c.click();
   });
      
   var c15 = document.getElementById("checkDisableDOMBattery");
   var c16 = document.getElementById("checkEnableDOMBattery");
   c15.checked = ! c16.checked;
   document.getElementById('checkDisableDOMBattery').addEventListener('CheckboxStateChange', function(){
	  var c = document.getElementById("checkEnableDOMBattery");
	  c.click();
   });

   var c17 = document.getElementById("checkDisableHealthReportService");
   var c18 = document.getElementById("checkEnableHealthReportService");
   c17.checked = ! c18.checked;
   document.getElementById('checkDisableHealthReportService').addEventListener('CheckboxStateChange', function(){
	  var c = document.getElementById("checkEnableHealthReportService");
	  c.click();
   });

   var c19 = document.getElementById("checkDisableHealthReportUpload");
   var c20 = document.getElementById("checkEnableHealthReportUpload");
   c19.checked = ! c20.checked;
   document.getElementById('checkDisableHealthReportUpload').addEventListener('CheckboxStateChange', function(){
	  var c = document.getElementById("checkEnableHealthReportUpload");
	  c.click();
   });

   var c21 = document.getElementById("checkDisableDataReportingSubmission");
   var c22 = document.getElementById("checkEnableDataReportingSubmission");
   c21.checked = ! c22.checked;
   document.getElementById('checkDisableDataReportingSubmission').addEventListener('CheckboxStateChange', function(){
	  var c = document.getElementById("checkEnableDataReportingSubmission");
	  c.click();
   });

   var c23 = document.getElementById("checkDisableDataReportingSubmissionV2");
   var c24 = document.getElementById("checkEnableDataReportingSubmissionV2");
   c23.checked = ! c24.checked;
   document.getElementById('checkDisableDataReportingSubmissionV2').addEventListener('CheckboxStateChange', function(){
	  var c = document.getElementById("checkEnableDataReportingSubmissionV2");
	  c.click();
   });
   
   var c25 = document.getElementById("checkDisableTelemetry");
   var c26 = document.getElementById("checkEnableTelemetry");
   c25.checked = ! c26.checked;
   document.getElementById('checkDisableTelemetry').addEventListener('CheckboxStateChange', function(){
	  var c = document.getElementById("checkEnableTelemetry");
	  c.click();
   });
   
   var c27 = document.getElementById("checkDisableTelemetryArchive");
   var c28 = document.getElementById("checkEnableTelemetryArchive");
   c27.checked = ! c28.checked;
   document.getElementById('checkDisableTelemetryArchive').addEventListener('CheckboxStateChange', function(){
	  var c = document.getElementById("checkEnableTelemetryArchive");
	  c.click();
   });
   
   var c29 = document.getElementById("checkDisableTelemetryUnified");
   var c30 = document.getElementById("checkEnableTelemetryUnified");
   c29.checked = ! c30.checked;
   document.getElementById('checkDisableTelemetryUnified').addEventListener('CheckboxStateChange', function(){
	  var c = document.getElementById("checkEnableTelemetryUnified");
	  c.click();
   });
   
}

function resetDefaults() {
   const nsIPrefService = Components.interfaces.nsIPrefService;

   var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(nsIPrefService).getBranch("extensions.SecretAgent.");

    // Reset SecretAgent.*
	secretAgentPreferences.getChildList('', {}).forEach( secretAgentPreferences.clearUserPref );

	document.getElementById("SecretAgentPreferences").acceptDialog();
}

function onCommandCheckRotateUserAgent() {

   var checkRotateUserAgent = document.getElementById("checkRotateUserAgent");

   if (!checkRotateUserAgent.checked)
   {
     // Restore default user agents
     clearGlobalUserAgentOverrides();
     clearAllDomainSpecificUserAgentOverrides();
   }

}
function onCommandCheckRotateOSCPU() {

   var checkRotateOSCPU = document.getElementById("checkRotateOSCPU");

   if (!checkRotateOSCPU.checked)
   {
     // Restore defaults OSCPU
     clearGlobalOSCPUOverrides();
   }
   
}

  //----------------------------------------------------------------------------------------------------
  // restore default preferences
function clearAllOverrides() {

	clearGlobalOSCPUOverrides();
	clearGlobalUserAgentOverrides();
	clearGlobalAcceptOverrides();
    clearAllDomainSpecificUserAgentOverrides();
	
}
  
  //----------------------------------------------------------------------------------------------------
  // restore default user agent override preferences for all domains
function clearGlobalUserAgentOverrides() {
   
    // Remove general.useragent.override
    var generalUserAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    generalUserAgentPreferences = generalUserAgentPreferences.getBranch("general.useragent.");

    try{ generalUserAgentPreferences.clearUserPref("override"); } catch(e) {
dump("Exception;" + e.message + "\n");
	}

}

  //----------------------------------------------------------------------------------------------------
  // restore default user agent override preferences for all domains
function clearGlobalOSCPUOverrides() {
   
    // Remove general.oscpu.override
    var generalOSCPUPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    generalOSCPUPreferences = generalOSCPUPreferences.getBranch("general.oscpu.");

    try{ generalOSCPUPreferences.clearUserPref("override"); } catch(e) {
dump("Exception;" + e.message + "\n");
    }

}

  //----------------------------------------------------------------------------------------------------
  // restore default accept header override preferences for all domains
function clearGlobalAcceptOverrides() {
   
    // Remove network.http.accept.default
    var networkHTTPAcceptPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    networkHTTPAcceptPreferences = networkHTTPAcceptPreferences.getBranch("network.http.accept.");

    try{ networkHTTPAcceptPreferences.clearUserPref("default"); } catch(e) {
dump("Exception;" + e.message + "\n");
	}

}

  //----------------------------------------------------------------------------------------------------
  // restore default preferences for all domain
function clearAllDomainSpecificUserAgentOverrides() {

    var generalUserAgentOverridePreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    generalUserAgentOverridePreferences = generalUserAgentOverridePreferences.getBranch("general.useragent.override.");

    // Remove general.useragent.override.*
	generalUserAgentOverridePreferences.getChildList('', {}).forEach( clearDomainSpecificUserAgentOverrides );
	
    try{ generalUserAgentOverridePreferences.deleteBranch(""); } catch(e) {
dump("Exception;" + e.message + "\n");
	}
	
}
	
  //----------------------------------------------------------------------------------------------------
  // restore default preferences for a given domain
function clearDomainSpecificUserAgentOverrides(domain) {
//alert("["+domain+"]");
    var generalUserAgentOverridePreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    generalUserAgentOverridePreferences = generalUserAgentOverridePreferences.getBranch("general.useragent.override.");

	// Remove general.useragent.override.<domain>
	// This may leave some third party overrides in place, these are cleared on exit
    try{ generalUserAgentOverridePreferences.clearUserPref( domain ); } catch(e) {
dump("Exception;" + e.message + "\n");
	}

}
  
  //----------------------------------------------------------------------------------------------------
  // automatically optimise privacy settings
function onAutoTunePrivacy() {
	var checkboxprefs = ["checkEnablePrivateBrowsingAutostart",
	"checkDisableGeoLocation"       ,"checkDisableKeywordSearch",
	"checkDisableGetAddonsCache"    ,"checkDisableNetworkPrefetch",
	"checkDisableDNSPrefetch"       ,"checkDisableWebRTC",
	"checkDisableBrowserCasting"    ,"checkEnableTrackingProtectionUI",
	"checkEnableTrackingProtection" ,"checkEnableAlwaysAcceptSessionCookies",
	"checkEnableThirdPartySessionCookiesOnly", "checkDisableBeacon",
	"checkDisableDOMBattery"        ,"checkEnableSanitizeOnShutdown",
	"checkEnableDoNotTrack"         ,"checkEnableRefererSpoofSource",
	"checkDisableHealthReportService","checkDisableHealthReportUpload",
	"checkDisableDataReportingSubmission", "checkDisableDataReportingSubmissionV2",
	"checkDisableTelemetry"         ,"checkDisableTelemetryArchive",
	"checkDisableTelemetryUnified"];
	var radioprefs = ["radioCookieBehaviourOriginatingServerOnly","radioCookieLifetimeSessionOnly",
	"radioRejectTracking"];
	var prefpane = document.getElementById("SecretAgentPreferencePane");
    var i;
	
	for (i = 0; i < checkboxprefs.length; i++) {
       var checkbox = document.getElementById(checkboxprefs[i]);
       if (!checkbox.checked) { checkbox.click();}
	}
	for (i = 0; i < radioprefs.length; i++) {
       var radio = document.getElementById(radioprefs[i]);
       if (!radio.selected) { radio.click();}
	}
	var e;
	e = document.getElementById("txtCookieLifetimeDays");
	e.value = 1;
	prefpane.userChangedValue(e);
	e = document.getElementById("txtCookieMaxNumber");
	e.value = 100;
	prefpane.userChangedValue(e);
	e = document.getElementById("txtCookieMaxNumberPerHost");
	e.value = 10;
	prefpane.userChangedValue(e);

	prefpane.writePreferences(true);
}